// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This header is hand-written, whereas most CSSProperty subclass
// headers are generated by
// core/css/properties/templates/Subclass.h.tmpl.
// CSSPropertyApplyAtRule and CSSPropertyVariable are treated as
// CSS properties in some places for convenience but are not really
// CSS properties.
#ifndef Variable_h
#define Variable_h

#include "core/css/properties/CSSProperty.h"

namespace blink {

class Variable : public CSSProperty {
 public:
  constexpr Variable(CSSPropertyID id) : CSSProperty(id) {}

  bool IsInherited() const override { return true; }
  bool IsAffectedByAll() const override { return false; }
};

}  // namespace blink

#endif  // Variable_h
